
VoidUIInteract = VoidUIInteract or {}
VoidUIInteract._path = ModPath
VoidUIInteract.options_path = SavePath .. "VoidUIInteract.json"
VoidUIInteract.options = {} 

function VoidUIInteract:Save()
	local file = io.open( self.options_path, "w+" )
	if file then
		file:write( json.encode( self.options ) )
		file:close()
	end
end

function VoidUIInteract:Load()
	local file = io.open( self.options_path, "r" )
	if file then
		self.options = json.decode( file:read("*all") )
		file:close()
	else
	log("No previous save found. Creating new using default values")
	local default_file = io.open(self._path .."default_values.json")
		if default_file then
			self.options = json.decode( default_file:read("*all") )
			self:Save()
		end
	end
end

VoidUIInteract.hook_files = {
	["lib/managers/hudmanager"] = {"managers/HudManager.lua"},
	["lib/managers/hudmanagerpd2"] = {"managers/HudManager.lua"},
	["lib/managers/hud/hudinteraction"] = {"hud/HudInteraction.lua"}
}



Hooks:Add("LocalizationManagerPostInit", "LocalizationManagerPostInit_VoidUIInteract", function( loc )
	local loc_path = VoidUIInteract._path .. "loc/"

	if file.DirectoryExists(loc_path) then
		for _, filename in pairs(file.GetFiles(loc_path)) do
			local str = filename:match('^(.*).json$')
			if str and Idstring(str) and Idstring(str):key() == SystemInfo:language():key() then
				loc:load_localization_file(loc_path .. filename)
				break
			end
		end
		loc:load_localization_file(loc_path .. "english.json", false)
	else
		log("Localization folder seems to be missing!")
	end
end)

Hooks:Add( "MenuManagerInitialize", "MenuManagerInitialize_VoidUIInteract", function( menu_manager )

	--[[
		Setup our callbacks as defined in our item callback keys, and perform our logic on the data retrieved.
	]]
	
	MenuCallbackHandler.callback_enable_interact = function(self, item)
		VoidUIInteract.options.enable_interact = item:value() == 'on'
		VoidUIInteract:Save()
	end
	
	MenuCallbackHandler.callback_show_interact = function(self, item)
		VoidUIInteract.options.show_interact = item:value() == 'on'
		VoidUIInteract:Save()
	end
	
	MenuCallbackHandler.callback_interact_scale = function(self, item)
		VoidUIInteract.options.interact_scale = item:value()
		VoidUIInteract:Save()
 	end
	
	MenuCallbackHandler.callback_interact_y = function(self, item)
		VoidUIInteract.options.interact_y = item:value()
		VoidUIInteract:Save()
 	end
	
	VoidUIInteract:Load()

	MenuHelper:LoadFromJsonFile( VoidUIInteract._path .. "menu/interact.json", VoidUIInteract, VoidUIInteract.options )

end )

if RequiredScript then
	local requiredScript = RequiredScript:lower()
		if VoidUIInteract.hook_files[requiredScript] then
			for _, file in ipairs(VoidUIInteract.hook_files[requiredScript]) do
			dofile( VoidUIInteract._path .. "lua/" .. file )
		end
	end
end